;
; This area has been provided for others who may know mIRC scripting to take advantage of some of the
; various dialogs and setting I've used in case they feel they may be able to improve on this addon
; in any honest way. What I mean by an 'honest way' is any way in which the script DOES NOT rip off my
; code. If you do modify this script in a way you feel may help it be more productive, or just clean
; the code a little bit, be sure to drop me a line and include your edited script in the e-mail.
; Please keep in mind that the following tips ONLY APPLY to the main dialogs, quake3gui and quake3gui2
;
; Tab Dialogs -                1   -  49
; Box Buttons -                50  -  99
; Text Boxes -                 100 - 199
; Button Boxes -               200 - 299
; DropBox Buttons -            300 - 399
; EditBox Buttons -            400 - 499
;
; NOTE: 
;       It seems as though mIRC will not take numbers over 500 in its dialogs, so you are limited to
;       a maximum number of 'Boxes' at 49 inclusive.
;
on *:DIALOG:quake3gui:*:* {
  set %q3_guiname quake3gui
  if ((%q3_allowcdkey == [ON]) && (%q3_pointrelease+ == [YES])) {
    set %q3cdkeyfile %q3_exe_folder $+ \baseq3\q3key
    if ($isfile(%q3cdkeyfile) == $true) {
      set %q3cdkey $read -l1 %q3cdkeyfile | set %q3cdkey $left(%q3cdkey,16)
    }
    elseif ($isfile(%q3cdkeyfile) == $false) {
      set %q3cdkey [FILE ERROR]
    }
    .timerq3cdunset 1 2 unset %q3cd*   
  }
  elseif ((%q3_allowcdkey == [ON]) && (%q3_pointrelease+ == [NO])) {
    set %q3cdconfig %q3_exe_folder $+ \baseq3\q3config.cfg
    if ($isfile(%q3cdconfig) == $true) {
      set %q3cdkey $read -s"seta cl_cdkey" %q3cdconfig | set %q3cdkey $remove(%q3cdkey,cl_cdkey,")
      if (%q3cdkey == $null) { set %q3cdkey [NOT FOUND] }
    }
    elseif ($isfile(%q3cdconfig) == $false) {
      set %q3cdkey [FILE ERROR]
    }
    .timerq3cdunset 1 2 unset %q3cd*   
  }
  elseif (%q3_allowcdkey == [OFF]) { set %q3cdkey [DISABLED] }
  if ($dname == %q3_guiname) {
    if ($devent == init) {
      writeini -n q3launch.ini Q3LSYS ScreenRes $window(-1).w $+ x $+ $window(-1).h
      did -ra %q3_guiname 103 $readini q3launch.ini FAVORITES totalservers (Max is $quake3maxservers $+ )
      did -ra %q3_guiname 400 %q3_exe
      did -ra %q3_guiname 401 $readini q3launch.ini Q3LSYS Q3RootPath
      did -ra %q3_guiname 402 $readini q3launch.ini Q3LSYS ScreenRes 
      did -ra %q3_guiname 403 $readini q3launch.ini Q3LSYS OS
      did -ra %q3_guiname 404 $readini q3launch.ini Q3LSYS InstallDate
      did -ra %q3_guiname 405 $readini q3launch.ini Q3LSYS Q3LVersion
      did -ra %q3_guiname 406 %q3cdkey
      did -ack %q3_guiname 300 -=[Please Select A Server]=-
      set %q3_servers 0
      :servers
      inc %q3_servers
      if (%q3_servers <= $readini q3launch.ini FAVORITES totalservers) {
        if (%q3_servers <= 9) { set %q3_servers 0 $+ %q3_servers }
        set %q3_favserv1 $readini q3launch.ini FAVORITES server [ $+ [ %q3_servers ] ]
        did -a %q3_guiname 300 %q3_favserv1
        goto servers
      }
    }
    if ($devent == sclick) {
      if ($did == 201) { dialog -x %q3_guiname | .timerq3chg 1 1 q3_chgpath }
      if ($did == 202) { dialog -x %q3_guiname | .timerq3uni 1 1 q3_unload }
      if ($did == 203) { q3servaddcheck }
      if ($did == 204) { q3batwrite }
      if ($did == 205) { q3serveditgui }
      if ($did == 206) { q3batwrite2 }
      if ($did == 207) { q3specify }
      if ($did == 208) { set %q3_allowcdkey [OFF] | dialog -x %q3_guiname | q3_determine }
      if ($did == 300) { set %q3_servselected $did(300) | if (%q3_servselected == -=[Please Select A Server]=-) { unset %q3_servselected } }
    }
  }
}
on *:DIALOG:quake3gui2:*:* {
  set %q3_guiname quake3gui2
  if ((%q3_allowcdkey == [ON]) && (%q3_pointrelease+ == [YES])) {
    set %q3cdkeyfile %q3_exe_folder $+ \baseq3\q3key
    if ($isfile(%q3cdkeyfile) == $true) {
      set %q3cdkey $read -l1 %q3cdkeyfile | set %q3cdkey $left(%q3cdkey,16)
    }
    elseif ($isfile(%q3cdkeyfile) == $false) {
      set %q3cdkey [FILE ERROR]
    }
    .timerq3cdunset 1 2 unset %q3cd*   
  }
  elseif ((%q3_allowcdkey == [ON]) && (%q3_pointrelease+ == [NO])) {
    set %q3cdconfig %q3_exe_folder $+ \baseq3\q3config.cfg
    if ($isfile(%q3cdconfig) == $true) {
      set %q3cdkey $read -s"seta cl_cdkey" %q3cdconfig | set %q3cdkey $remove(%q3cdkey,cl_cdkey,")
      if (%q3cdkey == $null) { set %q3cdkey [NOT FOUND] }
    }
    elseif ($isfile(%q3cdconfig) == $false) {
      set %q3cdkey [FILE ERROR]
    }
    .timerq3cdunset 1 2 unset %q3cd*   
  }
  elseif (%q3_allowcdkey == [OFF]) { set %q3cdkey [DISABLED] }
  if ($dname == %q3_guiname) {
    if ($devent == init) {
      writeini -n q3launch.ini Q3LSYS ScreenRes $window(-1).w $+ x $+ $window(-1).h
      did -ra %q3_guiname 103 $readini q3launch.ini FAVORITES totalservers (Max is $quake3maxservers $+ )
      did -ra %q3_guiname 400 %q3_exe
      did -ra %q3_guiname 401 $readini q3launch.ini Q3LSYS Q3RootPath
      did -ra %q3_guiname 402 $readini q3launch.ini Q3LSYS ScreenRes 
      did -ra %q3_guiname 403 $readini q3launch.ini Q3LSYS OS
      did -ra %q3_guiname 404 $readini q3launch.ini Q3LSYS InstallDate
      did -ra %q3_guiname 405 $readini q3launch.ini Q3LSYS Q3LVersion
      did -ra %q3_guiname 406 %q3cdkey
      did -ack %q3_guiname 300 -=[Please Select A Server]=-
      set %q3_servers 0
      :servers
      inc %q3_servers
      if (%q3_servers <= $readini q3launch.ini FAVORITES totalservers) {
        if (%q3_servers <= 9) { set %q3_servers 0 $+ %q3_servers }
        set %q3_favserv1 $readini q3launch.ini FAVORITES server [ $+ [ %q3_servers ] ]
        did -a %q3_guiname 300 %q3_favserv1
        goto servers
      }
    }
    if ($devent == sclick) {
      if ($did == 201) { dialog -x %q3_guiname | .timerq3chg 1 1 q3_chgpath }
      if ($did == 202) { dialog -x %q3_guiname | .timerq3uni 1 1 q3_unload }
      if ($did == 203) { q3servaddcheck }
      if ($did == 204) { q3batwrite }
      if ($did == 205) { q3serveditgui }
      if ($did == 206) { q3batwrite2 }
      if ($did == 207) { q3specify }
      if ($did == 208) { set %q3_allowcdkey [ON] | dialog -x %q3_guiname | q3_determine }
      if ($did == 300) { set %q3_servselected $did(300) | if (%q3_servselected == -=[Please Select A Server]=-) { unset %q3_servselected } }
    }
  }
}

;
; For all the following areas, NO HINTS are provided. If you truly know what you are doing, you can
; successfully edit this section. If not, STOP HERE!!
;

on *:DIALOG:q3_noexefound:*:* {
  set %q3_guiname q3_noexefound
  if ($dname == %q3_guiname) {
    if ($devent == sclick) {
      if ($did == 6) { .timerselectq3 1 1 q3_specifypath | dialog -x %q3_guiname } 
      if ($did == 7) {  dialog -m q3error q3error  }
    }
  }
}

on *:DIALOG:q3servadderror:*:* { 
  set %q3_guiname q3servadderror
  if ($dname == q3servadderror) {
    if ($devent == sclick) {
      if ($did == 3) { dialog -x %q3_guiname | q3_determine }
    }
  }
}

on *:DIALOG:q3specified:*:* { 
set %q3_guiname q3specified
  if ($dname == q3specified) {
    if ($devent == edit) {
      set %q3_servselected $did(2)
    }
    if ($devent == sclick) {
      if ($did == 3) { q3batwrite }
      if ($did == 4) { dialog -x %q3_guiname | q3_determine }
    }
  }
}

on *:DIALOG:q3servadd:*:* { 
  set %q3_guiname q3servadd
  if ($dname == q3servadd) {
    if ($devent == edit) {
      set %q3_favadd $did(2)
    }
    if ($devent == sclick) {
      if (($did == 3) && ($did(2) == $null)) { did -ra %q3_guiname 1 You Must Enter A Server Name Below | .timerq3servaderror 1 2 did -ra %q3_guiname 1 Enter The Server Name/IP You Wish To Add: | halt } 
      elseif (($did == 3) && ($did(2) != $null)) { q3afavadd }
      if ($did == 4) { dialog -x %q3_guiname | q3_determine }
    }
  }
}

on *:DIALOG:q3servedit:*:* { 
  set %q3_guiname q3servedit
  if ($dname == q3servedit) {
    set %q3_deletedservnum $read -w"* $+ %q3_servselected $+ " q3launch.ini
    set %q3_deletedservnum $left(%q3_deletedservnum,8)
    if ($devent == edit) {
      set %q3_faved.del $did(3)
    }
    if ($devent == sclick) {
      if ($did == 4) { 
        writeini q3launch.ini FAVORITES %q3_deletedservnum %q3_faved.del
        dialog -x q3servedit
        q3_determine
        unset %q3_servselected
      }
      if ($did == 5) {
        remini q3launch.ini FAVORITES %q3_deletedservnum %q3_servselected
        writeini q3launch.ini FAVORITES %q3_deletedservnum Deleted. Edit Server Via Edit Box
        dialog -x q3servedit
        q3_determine
        unset %q3_servselected
      }
      if ($did == 6) { dialog -x q3servedit | q3_determine | unset %q3_servselected }
    }
    if ($devent == init) {
      did -ra %q3_guiname 3 %q3_servselected
    }
  }
}

on *:DIALOG:q3determinerelease:*:* {
  set %q3_guiname q3determinerelease
  if ($dname == %q3_guiname) {
    if ($devent == sclick) {
      if ($did == 6) { set %q3_pointrelease+ [YES] | dialog -x %q3_guiname | dialog -m releasedetermined releasedetermined }
      if ($did == 7) { set %q3_pointrelease+ [NO] | dialog -x %q3_guiname | dialog -m releasedetermined releasedetermined }
    }
  }
}

on *:DIALOG:q3_exefound:*:* {
  set %q3_guiname q3_exefound
  if ($dname == %q3_guiname) {
    if ($devent == sclick) {
      if ($did == 6) { dialog -x %q3_guiname | dialog -m detectedquake3 detectedquake3 } 
      if ($did == 7) {  dialog -m q3error q3error  }
    }
  }
  if ($devent == init) {
    did -ra %q3_guiname 8 %q3_exe_folder
  }
}

on *:DIALOG:detectquake3:init:* {
  set %q3_guiname detectquake3
  if ($devent == init) {
    .timerdt1 1 1 did -c %q3_guiname 9
    .timerdt2 1 2 did -c %q3_guiname 10
    .timerdt3 1 3 did -c %q3_guiname 11
    .timerdt4 1 4 did -c %q3_guiname 12
    .timerdt5 1 5 did -c %q3_guiname 13
    .timerdt6 1 6 did -c %q3_guiname 14
    .timerdt7 1 7 did -c %q3_guiname 15
    .timerdt8 1 8 did -c %q3_guiname 16
    .timerdt10 1 5 did -g %q3_guiname 7 q3mirc.ico
    .timerdt11 1 5 did -g %q3_guiname 8 quake3.ico
    .timerdt12 1 1 did -a %q3_guiname 6 Welcome To The mIRC Quake3 Launcher Setup
    .timerdt13 1 3 did -a %q3_guiname 6 Approximate Duration Of Setup: 45 Seconds
    .timerdt14 1 5 did -a %q3_guiname 6 Now Determining Where Quake3 Resides
    .timerdt15 1 7 did -a %q3_guiname 6 mIRC Will Now Appear To *Freeze*, This Is Normal 
    .timerdt16 1 10  /quake3locator
  }
}
on *:DIALOG:detectedquake3:*:* { 
  set %q3_guiname detectedquake3
  if ($devent == init) {
    did -c %q3_guiname 9
    did -c %q3_guiname 10
    did -c %q3_guiname 11
    did -c %q3_guiname 12
    did -c %q3_guiname 13
    did -c %q3_guiname 14
    did -c %q3_guiname 15
    did -c %q3_guiname 16
    .timercd2 1 1 did -c %q3_guiname 17
    .timerdt2a 1 2 did -c %q3_guiname 18 
    .timerdt2b 1 3 did -c %q3_guiname 19
    .timerdt2c 1 4 did -c %q3_guiname 20 
    .timerdt2e 1 5 dialog -x %q3_guiname
    .timerdt2x 1 5 dialog -m q3determinerelease q3determinerelease
    .timerdt2l 1 1 did -a %q3_guiname 6 Quake3 Installation Verified! Continuing Setup ...
    .timerdt2m 1 3 did -a %q3_guiname 6 Setup Will Now Update Script Variables
  }
}

on *:DIALOG:releasedetermined:init:* {
  set %q3_guiname releasedetermined
  if ($devent == init) {
    did -c %q3_guiname 9
    did -c %q3_guiname 10
    did -c %q3_guiname 11
    did -c %q3_guiname 12
    did -c %q3_guiname 13
    did -c %q3_guiname 14
    did -c %q3_guiname 15
    did -c %q3_guiname 16
    did -c %q3_guiname 17
    did -c %q3_guiname 18 
    did -c %q3_guiname 19
    did -c %q3_guiname 20
    .timerdt2u 1 1 did -c %q3_guiname 21 
    .timerdt2e 1 2 did -c %q3_guiname 22 
    .timerdt2f 1 3 did -c %q3_guiname 23
    did -g %q3_guiname 7 q3mirc.ico
    did -g %q3_guiname 8 quake3.ico
    .timerdt2j 1 3 did -g %q3_guiname 7 quake3.ico
    .timerdt2k 1 3 did -g %q3_guiname 8 q3mirc.ico
    did -a %q3_guiname 6 Quake3 Release Verified! Continuing Setup ...
    .timerdt2m 1 2 did -a %q3_guiname 6 Setup Will Continue To Update Script Variables
    .timerdt2n 1 4 did -a %q3_guiname 6 mIRC Quake3 Launcher Installation Complete.
    .timerdt2r 1 6 did -a %q3_guiname 6 Thanks For Using The mIRC Quake3 Launcher. 
    .timerdt2s 1 7 did -a %q3_guiname 6 Now Exiting Installer. Happy Fraggin'!
    .timerdt2t 1 8 dialog -x %q3_guiname | q3launchini | unset %q3_exe_temp*
    .timerdt2 1 8 q3_determine
  }
}

on *:DIALOG:q3error:*:* { 
  set %q3_guiname q3error 
  if ($devent == init) {
    .timer 1 1 did -a %q3_guiname 4 Halting The Current Installation.
    .timer 1 3 did -a %q3_guiname 4 Setup Has Detected An Error
    .timer 1 3 dialog -x %q3_guiname
    .timer 1 3 dialog -m q3questionit q3questionit
  }
}

on *:DIALOG:q3error2:init:* { 
  set %q3_guiname q3error2
  if ($devent == init) {
    .timer 1 1 did -a %q3_guiname 4 Halting The Current Installation.
    .timer 1 3 did -a %q3_guiname 4 Setup Has Detected An Error
    .timer 1 3 dialog -x %q3_guiname
    .timer 1 3 dialog -m q3questionit2 q3questionit2
  }
}

on *:DIALOG:q3questionit:*:* {
  set %q3_guiname q3questionit 
  if ($devent == sclick) {
    if ($did == 5) { dialog -m detectquake3 detectquake3 | dialog -x %q3_guiname }
    if ($did == 6) { dialog -x %q3_guiname | dialog -m q3addonuninstall q3addonuninstall }
  }
}
on *:DIALOG:q3addonuninstall:*:* {
  set %q3_guiname q3addonuninstall
  if ($devent == init) {
    .timer 1 3 did -a %q3_guiname 6 Now Removing Script Variables
    .timer 1 6 did -a %q3_guiname 6 Re-Run Installation If You Wish To Reinstall.
    .timer 1 7 did -a %q3_guiname 6 Uninstallation Complete. 
    .timer 1 8 did -a %q3_guiname 6 Thanks For Trying The mIRC Quake3 Launcher.
    .timer 1 10 did -a %q3_guiname 6 Now Exiting The Uninstaller.
    .timer 1 10 dialog -x %q3_guiname
    .timer 1 1 did -c %q3_guiname 7
    .timer 1 2 did -c %q3_guiname 8
    .timer 1 3 did -c %q3_guiname 9
    .timer 1 4 did -c %q3_guiname 10
    .timer 1 5 did -c %q3_guiname 11
    .timer 1 6 did -c %q3_guiname 12
    .timer 1 7 did -c %q3_guiname 13
    .timer 1 6 did -c %q3_guiname 14
    .timer 1 5 did -c %q3_guiname 15
    .timer 1 4 did -c %q3_guiname 16
    .timer 1 3 did -c %q3_guiname 17
    .timer 1 2 did -c %q3_guiname 18
    .timer 1 1 did -c %q3_guiname 19
  }
}