;
; This area has been provided for others who may know mIRC scripting to take advantage of some of the
; various dialogs and setting I've used in case they feel they may be able to improve on this addon
; in any honest way. What I mean by an 'honest way' is any way in which the script DOES NOT rip off my
; code. If you do modify this script in a way you feel may help it be more productive, or just clean
; the code a little bit, be sure to drop me a line and include your edited script in the e-mail.
; Please keep in mind that the following tips ONLY APPLY to the main dialogs, quake3gui and quake3gui2
;
; Tab Dialogs -                1   -  49
; Box Buttons -                50  -  99
; Text Boxes -                 100 - 199
; Button Boxes -               200 - 299
; DropBox Buttons -            300 - 399
; EditBox Buttons -            400 - 499
;
; NOTE: 
;       It seems as though mIRC will not take numbers over 500 in its dialogs, so you are limited to
;       a maximum number of 'Boxes' at 49 inclusive.
;
dialog quake3gui {
  title "Quake3 Addon By Digit4l <oldirty@vqf.com>"
  size -1 -1 150 160
  option dbu
  ;Options Tab
  tab "Options", 1, 1 1 150 155
  text "Location Of Selected Quake3.exe:", 100, 10 94 60 50, tab 1, center
  text "If You're Sure You Want To Uninstall, Please Click Below", 101, 82 98 63 20, tab 1, center
  text "Total Entries Detected:", 102, 107 26 32 14, center, tab 1
  ;
  ;The following text box is empty, but is where the final determination of total servers appears
  ;
  text "", 103, 105 42 36 14, center, tab 1
  text "Launch Quake3", 104, 10 64 40 7, tab 1
  text "Launch Quake3", 105, 56 64 40 7, tab 1
  text "Q3A CDKey Scan", 106, 100 64 45 7, tab 1
  button "&Quit", 200, 50 142 48 15, tab 1, ok
  button "&Change", 201, 17 122 47 12, default, tab 1
  button "&Uninstall", 202, 90 122 47 12, tab 1
  button "&Add", 203, 10 41 28 10, tab 1
  button "&Connect", 204, 38 41 30 10, tab 1
  button "&Edit/Delete", 205, 68 41 32 10, tab 1
  button "&Default Launch", 206, 54 73 42 10, tab 1
  button "&Specify Server", 207, 8 73 41 10, tab 1
  button "&Disable Scan", 208, 101 73 42 10, tab 1
  combo 300, 10 27 90 150, drop sort autovs, tab 1
  edit "", 400, 9 109 61 10, tab 1, center read autohs
  box " Quake3.exe File ", 50, 5 87 71 50, tab 1
  box " Favorite Servers ", 51, 5 18 142 37, tab 1
  box " Uninstall?!? ", 52, 77 87 71 50, tab 1
  box " Other Options ", 53, 5 56 142 30, tab 1

  ; Settings Tab
  tab "Information", 2
  text "Detected Q3:Arena Installation:", 119, 10 28 130 7, tab 2
  text "Monitor Resolution:", 120, 10 38 90 10, tab 2, read
  text "Operating System:", 121, 10 48 90 10, tab 2, read
  text "Script Install Date:", 122, 10 58 90 10, tab 2, read
  text "Q3A Launcher Version:", 123, 10 68 90 10, tab 2, read
  text "Q3A CDKey:", 124, 10 78 90 10, tab 2, read
  text "Quake3:Arena is 1999 id Software", 125, 5 129 140 7, tab 2, center
  text "Quake3 Official Site: http://www.quake3arena.com", 126, 5 136 140 7, tab 2, center
  text "id Software Official Site: http://www.idsoftware.com", 127, 5 143 140 7, tab 2, center
  text "PlanetQuake: http://www.planetquake.com", 128, 5 150 140 7, tab 2, center
  edit "Processing ...", 401, 92 27 50 10, tab 2, center read autohs
  edit "Processing ...", 402, 92 37 50 10, tab 2, center read
  edit "Processing ...", 403, 92 47 50 10, tab 2, center read
  edit "Processing ...", 404, 92 57 50 10, tab 2, center read
  edit "Processing ...", 405, 92 67 50 10, tab 2, center read
  edit "Processing ...", 406, 92 77 50 10, tab 2, center read
  box " Quake3 Launcher Detection ", 56, 5 18 142 106, tab 2

  ; Usage Tab
  tab "Usage", 3
  text "Using This Addon Is Simple, You Simply Select Your Server From The Drop Down Box, Or Manually Specify It By Clicking The Button Provided. This mIRC Add-on Is Feature Packed, As You Can See When You Launch The GUI. You May Also Use Four Command Line Interpreters Through mIRC From Your Usual Editbox," 107, 9 26 132 50, tab 3
  text "'/quake3 ip-address' Or '/quake3' (For Single Player)", 108, 5 68 142 10, center, tab 3
  text "-=OR=-", 109, 5 75 142 10, center, tab 3
  text "'/q3 ip-address' Or '/q3' (For Single Player)", 110, 5 82 142 10, center, tab 3
  text "A More Definitive Help File Will Accompany This Add-on In A Future Release.", 111, 5 92 142 14, center, tab 3
  text " -=Creator=- ", 112, 5 116 32 7, tab 3
  text " -=[Digit4l]=- ", 113, 115 116 32 7, right, tab 3
  text " -=Ideas=- ", 114, 5 124 32 7, tab 3
  text " ircN mIRC Script ", 115, 85 124 62 7, right, tab 3
  text " -=Shout Outz=- ", 116, 5 132 57 7, tab 3
  text " Rush, Axe, DaSpam ", 117, 95 132 52 7, right, tab 3
  text " My Next Release Will Include Bug Fixes (If Any), An Improved Edit/Delete Feature, And GAMESPY Support!! ", 118, 8 144 138 14, center, tab 3
  box " General Usage ", 54, 5 18 142 89, tab 3
  box " Credits ", 55, 5 109 142 32, tab 3

  ; Basic Background
  text "mIRC Quake3 Addon 2000 -=Digital Oxygen=-", 129, 19 165 115 7, center
}

dialog quake3gui2 {
  title "Quake3 Addon By Digit4l <oldirty@vqf.com>"
  size -1 -1 150 160
  option dbu
  ;Options Tab
  tab "Options", 1, 1 1 150 155
  text "Location Of Selected Quake3.exe:", 100, 10 94 60 50, tab 1, center
  text "If You're Sure You Want To Uninstall, Please Click Below", 101, 82 98 63 20, tab 1, center
  text "Total Entries Detected:", 102, 107 26 32 14, center, tab 1
  ;
  ;The following text box is empty, but is where the final determination of total servers appears
  ;
  text "", 103, 105 42 36 14, center, tab 1
  text "Launch Quake3", 104, 10 64 40 7, tab 1
  text "Launch Quake3", 105, 56 64 40 7, tab 1
  text "Q3A CDKey Scan", 106, 100 64 45 7, tab 1
  button "&Quit", 200, 50 142 48 15, tab 1, ok
  button "&Change", 201, 17 122 47 12, default, tab 1
  button "&Uninstall", 202, 90 122 47 12, tab 1
  button "&Add", 203, 10 41 28 10, tab 1
  button "&Connect", 204, 38 41 30 10, tab 1
  button "&Edit/Delete", 205, 68 41 32 10, tab 1
  button "&Default Launch", 206, 54 73 42 10, tab 1
  button "&Specify Server", 207, 8 73 41 10, tab 1
  button "&Enable Scan", 208, 101 73 42 10, tab 1
  combo 300, 10 27 90 150, drop sort autovs, tab 1
  edit "", 400, 9 109 61 10, tab 1, center read autohs
  box " Quake3.exe File ", 50, 5 87 71 50, tab 1
  box " Favorite Servers ", 51, 5 18 142 37, tab 1
  box " Uninstall?!? ", 52, 77 87 71 50, tab 1
  box " Other Options ", 53, 5 56 142 30, tab 1

  ; Settings Tab
  tab "Information", 2
  text "Detected Q3:Arena Installation:", 119, 10 28 130 7, tab 2
  text "Monitor Resolution:", 120, 10 38 90 10, tab 2, read
  text "Operating System:", 121, 10 48 90 10, tab 2, read
  text "Script Install Date:", 122, 10 58 90 10, tab 2, read
  text "Q3A Launcher Version:", 123, 10 68 90 10, tab 2, read
  text "Q3A CDKey:", 124, 10 78 90 10, tab 2, read
  text "Quake3:Arena is 1999 id Software", 125, 5 129 140 7, tab 2, center
  text "Quake3 Official Site: http://www.quake3arena.com", 126, 5 136 140 7, tab 2, center
  text "id Software Official Site: http://www.idsoftware.com", 127, 5 143 140 7, tab 2, center
  text "PlanetQuake: http://www.planetquake.com", 128, 5 150 140 7, tab 2, center
  edit "Processing ...", 401, 92 27 50 10, tab 2, center read autohs
  edit "Processing ...", 402, 92 37 50 10, tab 2, center read
  edit "Processing ...", 403, 92 47 50 10, tab 2, center read
  edit "Processing ...", 404, 92 57 50 10, tab 2, center read
  edit "Processing ...", 405, 92 67 50 10, tab 2, center read
  edit "Processing ...", 406, 92 77 50 10, tab 2, center read
  box " Quake3 Launcher Detection ", 56, 5 18 142 106, tab 2

  ; Usage Tab
  tab "Usage", 3
  text "Using This Addon Is Simple, You Simply Select Your Server From The Drop Down Box, Or Manually Specify It By Clicking The Button Provided. This mIRC Add-on Is Feature Packed, As You Can See When You Launch The GUI. You May Also Use Four Command Line Interpreters Through mIRC From Your Usual Editbox," 107, 9 26 132 50, tab 3
  text "'/quake3 ip-address' Or '/quake3' (For Single Player)", 108, 5 68 142 10, center, tab 3
  text "-=OR=-", 109, 5 75 142 10, center, tab 3
  text "'/q3 ip-address' Or '/q3' (For Single Player)", 110, 5 82 142 10, center, tab 3
  text "A More Definitive Help File Will Accompany This Add-on In A Future Release.", 111, 5 92 142 14, center, tab 3
  text " -=Creator=- ", 112, 5 116 32 7, tab 3
  text " -=[Digit4l]=- ", 113, 115 116 32 7, right, tab 3
  text " -=Ideas=- ", 114, 5 124 32 7, tab 3
  text " ircN mIRC Script ", 115, 85 124 62 7, right, tab 3
  text " -=Shout Outz=- ", 116, 5 132 57 7, tab 3
  text " Rush, Axe, DaSpam ", 117, 95 132 52 7, right, tab 3
  text " My Next Release Will Include Bug Fixes (If Any), An Improved Edit/Delete Feature, And GAMESPY Support!! ", 118, 8 144 138 14, center, tab 3
  box " General Usage ", 54, 5 18 142 89, tab 3
  box " Credits ", 55, 5 109 142 32, tab 3

  ; Basic Background
  text "mIRC Quake3 Addon 2000 -=Digital Oxygen=-", 129, 19 165 115 7, center
}

;
; For all the following areas, NO HINTS are provided. If you truly know what you are doing, you can
; successfully edit this section. If not, STOP HERE!!
;

dialog q3_noexefound {
  title "mIRC Quake3 Launcher Inquiry"
  option dbu
  button "", 1, 0 0 0 0, cancel hide
  size -1 -1 110 36
  text "Setup Was Unable To Find Quake3.exe", 2, 5 3 100 7, center
  text "Would You Like To Specify The Location Of Quake3.exe?", 3, 3 10 105 14, center
  text "Selecting No Will Abort Installation.", 4, 5 24 102 7, center
  button "&Yes", 6, 34 33 22 12, ok default
  button "&No", 7, 56 33 22 12, cancel
}

dialog q3servadderror {
  title "Quake3 Addon - Error!"
  option dbu
  size -1 -1 100 23
  icon 15, 5 8 32 32, quake3error.ico
  button "", 1, 0 0 0 0, cancel disable
  text "It Seems You Have Reached The Maximum Allowed Servers!!", 2, 22 3 80 20, center
  button "Oops!", 3, 40 19 40 12 ok default
}

dialog q3specified {
  title "Quake3 Addon - Specify Server"
  size -1 -1 112 26
  option dbu
  text "Please Specify The Server To Connect To:", 1, 2 3 112 10, center
  edit "", 2, 5 11 105 10, center, return
  button "&Take Me There!", 3, 5 23 50 12, ok
  button "&Nevermind", 4, 60 23 50 12
}

dialog q3servadd {
  title "Quake3 Addon - Add Server"
  size -1 -1 112 26
  option dbu
  text "Enter The Server Name/IP You Wish To Add:", 1, 2 3 112 7, center
  edit "", 2, 5 11 105 10, center, return
  button "&Add To Server List", 3, 5 23 50 12, ok
  button "&Nevermind", 4, 60 23 50 12
}

dialog q3servedit {
  title "Quake3 Addon - Edit/Delete Server"
  size -1 -1 123 34
  option dbu
  text "Edit or Delete This Server?", 1, 2 3 121 10, center
  text " To Edit Port, Use IP:PORT, Else Function Fails", 2, 1 10 121 10, center
  edit "", 3, 5 18 116 10, center, return
  button "&Save Changes", 4, 5 30 39 12, ok
  button "Delete Server", 5, 44 30 38 12
  button "&Nevermind", 6, 82 30 39 12
}

dialog q3determinerelease {
  title "mIRC Quake3 Launcher Inquiry"
  option dbu
  size -1 -1 110 40
  icon 15, 5 5 32 32, q3question.ico
  button "", 1, 0 0 0 0, cancel hide
  text "To Properly Complete Installation,", 2, 25 5 100 7, read
  text "We Require More Info From You.", 3, 25 12 102 14
  text "Have You Installed The Quake3", 4, 25 19 90 7
  text "Point Release Beta Or Better?", 5, 25 26 90 7
  button "&Yes", 6, 38 36 20 12 ok default
  button "&No", 7, 58 36 20 12 cancel
}

dialog q3_exefound {
  title "mIRC Quake3 Launcher Inquiry"
  option dbu
  button "", 1, 0 0 0 0, cancel hide
  size -1 -1 110 39
  text "Setup Successfully Detected Quake3.exe", 2, 5 3 100 7, center
  text "Use The Quake3.exe Found In:", 3, 3 10 105 7, center
  edit "", 8, 3 17 107 10, center autohs
  text "Selecting No Will Abort Installation.", 4, 5 27 102 7, center
  button "&Yes", 6, 34 36 22 12, ok default
  button "&No", 7, 56 36 22 12, cancel
}

dialog detectquake3 {
  title "mIRC Quake3 Launcher Installer By Digit4l"
  size -1 -1 150 43
  option dbu
  button "", 1, 0 0 0 0, cancel hide
  radio "", 9, 10 29 7 7
  radio "", 10, 19 29 7 7
  radio "", 11, 28 29 7 7
  radio "", 12, 37  29 7 7
  radio "", 13, 46 29 7 7
  radio "", 14, 55 29 7 7
  radio "", 15, 64 29 7 7
  radio "", 16, 73 29 7 7
  radio "", 17, 82 29 7 7
  radio "", 18, 91 29 7 7
  radio "", 19, 100 29 7 7
  radio "", 20, 109 29 7 7
  radio "", 21, 118 29 7 7
  radio "", 22, 127 29 7 7
  radio "", 23, 136 29 7 7
  icon 7, 5 5 16 16, quake3.ico
  icon 8, 133 5 16 16, q3mirc.ico
  text "", 6, 1 45 148 7, center
  text "mIRC Quake3 Add-On Installer", 2, 25 5 105 7, center
  text "Now Searching For Quake3.exe On C:\", 3, 25 12 105 7, center
  box "", 5, 5 20 143 21, center
}

dialog detectedquake3 {
  title "mIRC Quake3 Launcher Installer By Digit4l"
  size -1 -1 150 43
  option dbu
  button "", 1, 0 0 0 0, cancel hide
  radio "", 9, 10 29 7 7
  radio "", 10, 19 29 7 7
  radio "", 11, 28 29 7 7
  radio "", 12, 37  29 7 7
  radio "", 13, 46 29 7 7
  radio "", 14, 55 29 7 7
  radio "", 15, 64 29 7 7
  radio "", 16, 73 29 7 7
  radio "", 17, 82 29 7 7
  radio "", 18, 91 29 7 7
  radio "", 19, 100 29 7 7
  radio "", 20, 109 29 7 7
  radio "", 21, 118 29 7 7
  radio "", 22, 127 29 7 7
  radio "", 23, 136 29 7 7
  icon 7, 5 5 16 16, quake3.ico
  icon 8, 133 5 16 16, q3mirc.ico
  text "Quake3 Installation Verified! Continuing Setup ...", 6, 1 45 148 7, center
  text "mIRC Quake3 Add-On Installer", 2, 25 5 105 7, center
  text "Quake3 Appears To Be User Defined", 3, 25 12 105 7, center
  box "", 5, 5 20 143 21, center
}

dialog releasedetermined {
  title "mIRC Quake3 Launcher Installer By Digit4l"
  size -1 -1 150 43
  option dbu
  button "", 1, 0 0 0 0, cancel hide
  radio "", 9, 10 29 7 7
  radio "", 10, 19 29 7 7
  radio "", 11, 28 29 7 7
  radio "", 12, 37  29 7 7
  radio "", 13, 46 29 7 7
  radio "", 14, 55 29 7 7
  radio "", 15, 64 29 7 7
  radio "", 16, 73 29 7 7
  radio "", 17, 82 29 7 7
  radio "", 18, 91 29 7 7
  radio "", 19, 100 29 7 7
  radio "", 20, 109 29 7 7
  radio "", 21, 118 29 7 7
  radio "", 22, 127 29 7 7
  radio "", 23, 136 29 7 7
  icon 7, 5 5 16 16, quake3.ico
  icon 8, 133 5 16 16, q3mirc.ico
  text "", 6, 1 45 148 7, center
  text "mIRC Quake3 Add-On Installer", 2, 25 5 105 7, center
  text "Quake3 Appears To Be User Defined", 3, 25 12 105 7, center
  box "", 5, 5 20 143 21, center
}

dialog q3error {
  title "Quake3 Launcher Installer Error"
  option dbu
  size -1 -1 115 19
  button "", 1, 0 0 0 0, cancel hide
  text "mIRC Quake3 Add-On Installer", 2, 26 5 80 7, read
  text "Fatal Error - Installation Aborted!", 3, 26 12 80 7
  text "No Quake3.exe Found or Specified", 4, 26 19 100 7
  icon 5, 5 5 16 16, quake3error.ico
}

dialog q3error2 {
  title "Quake3 Launcher Installer Error"
  option dbu
  size -1 -1 115 19
  button "", 1, 0 0 0 0, cancel hide
  text "mIRC Quake3 Add-On Installer", 2, 26 5 80 7, read
  text "Fatal Error - Installation Aborted!", 3, 26 12 80 7
  text "No Quake3.exe Found or Specified", 4, 26 19 100 7
  icon 5, 5 5 16 16, quake3error.ico
}

dialog q3addonuninstall {
  title "Quake3 Launcher Uninstaller By Digit4l"
  option dbu
  size -1 -1 144 40
  button "", 1, 0 0 0 0, cancel hide
  text "mIRC Quake3 Add-On Uninstaller", 2, 0 5 144 7, center read
  text "Now Uninstalling The mIRC Quake3 Add-On", 3, 0 12 144 7, center
  box "", 5, 7 18 133 21, center
  text "Uninstallation Underway...Please Wait", 6, 0 41 144 7, center
  radio "", 7, 10 27 7 7
  radio "", 8, 20 27 7 7
  radio "", 9, 30 27 7 7
  radio "", 10, 40 27 7 7
  radio "", 11, 50 27 7 7
  radio "", 12, 60 27 7 7
  radio "", 13, 70 27 7 7
  radio "", 14, 80 27 7 7
  radio "", 15, 90 27 7 7
  radio "", 16, 100 27 7 7
  radio "", 17,110 27 7 7
  radio "", 18, 120 27 7 7
  radio "", 19, 130 27 7 7
}

dialog q3questionit {
  title "mIRC Quake3 Launcher Inquiry"
  option dbu
  size -1 -1 115 32
  icon 15, 7 7 16 16, quake3error.ico
  button "", 1, 0 0 0 0, cancel hide
  text "mIRC Quake3 Launcher Error", 2, 28 5 100 7, read
  text "Fatal Error - Installation Interrupted", 3, 28 12 100 7
  text "Would You Like To Restart Setup?", 4, 28 19 100 7
  button "&Yes", 5, 35 28 25 12, ok default
  button "&No", 6, 60 28 25 12 cancel
}